/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_font.h"


const char szFaceNameSB_def[] = "Arial Black";
const char szFaceNameMB_def[] = "lr SVbN";

//--- font object ---
static wgl_font		wglfont(szFaceNameSB_def, szFaceNameMB_def);


//---------
//  
//---------
void
init_font()
{
	// r̐ݒ
	wglfont.set_ruby_size(0.5f);
	wglfont.enable_ruby(true);
}

void
set_facename_SB(const char* facename)
{
	wglfont.set_facename_SB(facename);
}

void
set_facename_MB(const char* facename)
{
	wglfont.set_facename_MB(facename);
}



//--------------
//  {IȊ֐
//--------------
wgl_font&
get_font()
{
	return wglfont;
}

void
draw_text(const char* str)
{
	wglfont.draw_text(str);
}

void
draw_text_center(const char* str)
{
	wglfont.prepare_centering(str);
	wglfont.draw_text(str);
}

void
draw_textf(const char* szFormat, ...)
{
	static char		szBuffer[1024];
	va_list			pArgs;

	va_start( pArgs, szFormat );
	vsprintf( szBuffer, szFormat, pArgs );
	va_end( pArgs );
	
	draw_text(szBuffer);
}

void
prepare_centering(const char* str)
{
	wglfont.prepare_centering(str);
}

void
prepare_flushright(const char* str)
{
	wglfont.prepare_flushright(str);
}

void
draw_per_capita_basis(float w0, const char* str)
{
	wglfont.draw_per_capita_basis(w0, str);
}

void
EnableRuby(bool flg)
{
	wglfont.enable_ruby(flg);
}

int
get_text_size(const char* str, float& w, float& h)
{
	return wglfont.get_text_size(str, w,h);
}
