/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_SCREEN_H__
#define __MTK_SCREEN_H__
#include  "../common/graphics/gl_common.h"


//*****
extern float screen_z;
extern float screen_w;
extern float z_near;
extern float z_mid;
extern float z_far2;
extern float ini_obj_z;
extern double g_scale_last;		// O̒li|bvAbvp@OnSetZoomŃZbg)


//-------------
//  Functions
//-------------
//--  screen --
float	get_screen_z();
float	get_screen_w();
//--  frustum  --
frustum	get_frustum_near(int w, int h);
frustum	get_frustum_far(int w, int h);
//--  Eye  --
float	get_eye_offset_x();
void	set_eye_offset_x(float x);
float	get_screen_offset_x();
void	set_screen_offset_x(float x);
char	get_eye_CLR();
void	set_eye_CLR(char CLR);
float	get_eye_distance();
void	set_eye_distance(float dist);


double	get_clst_R();
double	get_current_scale();
void	set_scale(const double& scl);
double	calc_scale_factor(const double& scl);
double	get_scale_factor();
float	get_Rmax();

//--  Celestial Sphere
double	adjust_far_pos(vector3d& pos, const double& scale_factor);
//--  Pixel
float	get_rad_per_pixel(int w, int h);
//--  Fade angle
void	set_fade_angle_factor(float fac);
float	get_fade_angle_factor();


#endif
