/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MITAKA_H__
#define __MITAKA_H__
#include  "../common/math/vector3.h"
#include  <vector>
using namespace std;



//------------------
//  Window Message
//------------------
#define  WM_GRAPHNOTIFY		(WM_USER+1)


//-----------
//  Defines
//-----------

//---  Modes  ---
enum {
	MODE_PLANETARIUM,
	MODE_HIPPARCOS
};

//---  Sub Modes  ---
enum {
	SUBMODE_NORMAL,		// ʏ̑
	SUBMODE_SETTING,	// ݒ
	SUBMODE_MENU,		// j[
	SUBMODE_POINTER,	// |C^
	SUBMODE_TITLE,		// ^Cg[h
	SUBMODE_IMAGE,		// C[W[h
	SUBMODE_3DCHART,	// 3D `[g
	SUBMODE_AUTOPLAY	// s[h
};

//---  File  ---
// read status
enum {
	FILE_SUCCESS,
	FILE_SKIP,
	FILE_FAILED
};



//--- Constants ---
const float pi = 3.14159265358979323;




//-----------------------------------------
//  ^C}[:  joystick, Aj[VŎgp
//-----------------------------------------
const int	TIMER_INTERVAL = 15;		// ^C}荞݂̊Ԋu (in msec)




//-----------
//  _f
//-----------
class point_group
{
public:
	vector3f	rc;
	vector<int>	pt_idx;
};

class point_model
{
public:
	vector<vector3f>		point;
	vector<point_group>		group_list;
};



enum {
	ANIM_TY_NONE,
	ANIM_TY_ZOOMIN_IMAGE,	// C[W̃Y[C
	ANIM_TY_ZOOMOUT_IMAGE,	// C[W̃Y[AEg
	ANIM_TY_CREDIT_SCROLL,	// NWbg̃XN[
	ANIM_TY_TITLE,			// ^Cg̃Aj[V
	ANIM_TY_THEME,			// e[}̃Aj[V
	ANIM_TY_PLAY			// pXĐ
};


//-----------
//  Externs
//-----------
extern float screen_z, screen_w;


#endif